## postgres-xc 1.1

=== config/Makefile ===
# config/Makefile

subdir = config
top_builddir = ..
include $(top_builddir)/src/Makefile.global


install: all installdirs
	$(INSTALL_SCRIPT) $(srcdir)/install-sh '$(DESTDIR)$(pgxsdir)/config/install-sh'

installdirs:
	$(MKDIR_P) '$(DESTDIR)$(pgxsdir)/config'

uninstall:
	rm -f '$(DESTDIR)$(pgxsdir)/config/install-sh'

=== contrib/Makefile ===
# contrib/Makefile

subdir = contrib
top_builddir = ..
include $(top_builddir)/src/Makefile.global

SUBDIRS = \
		adminpack	\
		auth_delay	\
		auto_explain	\
		btree_gin	\
		btree_gist	\
		chkpass		\
		citext		\
		cube		\
		dblink		\
		dict_int	\
		dict_xsyn	\
		dummy_seclabel	\
		earthdistance	\
		file_fdw	\
		fuzzystrmatch	\
		hstore		\
		intagg		\
		intarray	\
		isn		\
		lo		\
		ltree		\
		oid2name	\
		pageinspect	\
		passwordcheck	\
		pg_archivecleanup \
		pg_buffercache	\
		pg_freespacemap \
		pg_standby	\
		pg_stat_statements \
		pg_test_fsync	\
		pg_test_timing	\
		pg_trgm		\
		pg_upgrade	\
		pg_upgrade_support \
		pgbench		\
		pgcrypto	\
		pgrowlocks	\
		pgstattuple	\
		pgxc_clean	\
		seg		\
		spi		\
		tablefunc	\
		tcn		\
		test_parser	\
		tsearch2	\
		unaccent	\
		vacuumlo

ifeq ($(with_openssl),yes)
SUBDIRS += sslinfo
else
ALWAYS_SUBDIRS += sslinfo
endif

ifeq ($(with_ossp_uuid),yes)
SUBDIRS += uuid-ossp
else
ALWAYS_SUBDIRS += uuid-ossp
endif

ifeq ($(with_libxml),yes)
SUBDIRS += xml2
else
ALWAYS_SUBDIRS += xml2
endif

ifeq ($(with_selinux),yes)
SUBDIRS += sepgsql
else
ALWAYS_SUBDIRS += sepgsql
endif

# Missing:
#		start-scripts	\ (does not have a makefile)


$(recurse)
$(recurse_always)

=== doc-xc/Makefile ===
#----------------------------------------------------------------------------
#
# Postgres-XC documentation top-level makefile
#
# Copyright (c) 1994, Regents of the University of California
#
# doc/Makefile
#
#----------------------------------------------------------------------------

subdir = doc-xc
top_builddir = ..
include $(top_builddir)/src/Makefile.global

all distprep html man install installdirs uninstall clean distclean maintainer-clean maintainer-check:
	$(MAKE) -C src $@

=== src/Makefile ===
#-------------------------------------------------------------------------
#
# Makefile for src
#
# Copyright (c) 1994, Regents of the University of California
#
# src/Makefile
#
#-------------------------------------------------------------------------

subdir = src
top_builddir = ..
include Makefile.global

SUBDIRS = \
	port \
	timezone \
	gtm \
	interfaces \
	pgxc \
	backend \
	backend/utils/mb/conversion_procs \
	backend/snowball \
	include \
	backend/replication/libpqwalreceiver \
	bin \
	pl \
	makefiles \
	test/regress

# There are too many interdependencies between the subdirectories, so
# don't attempt parallel make here.
.NOTPARALLEL:

$(recurse)

install: install-local

install-local: installdirs-local
	$(INSTALL_DATA) Makefile.global '$(DESTDIR)$(pgxsdir)/$(subdir)/Makefile.global'
	$(INSTALL_DATA) Makefile.port '$(DESTDIR)$(pgxsdir)/$(subdir)/Makefile.port'
	$(INSTALL_DATA) $(srcdir)/Makefile.shlib '$(DESTDIR)$(pgxsdir)/$(subdir)/Makefile.shlib'
	$(INSTALL_DATA) $(srcdir)/nls-global.mk '$(DESTDIR)$(pgxsdir)/$(subdir)/nls-global.mk'

installdirs: installdirs-local

installdirs-local:
	$(MKDIR_P) '$(DESTDIR)$(pgxsdir)/$(subdir)'

uninstall: uninstall-local

uninstall-local:
	rm -f $(addprefix '$(DESTDIR)$(pgxsdir)/$(subdir)'/, Makefile.global Makefile.port Makefile.shlib nls-global.mk)

distprep:
	$(MAKE) -C test/isolation $@

clean:
	$(MAKE) -C test $@
	$(MAKE) -C tutorial NO_PGXS=1 $@
	$(MAKE) -C test/isolation $@
	$(MAKE) -C test/thread $@

distclean maintainer-clean:
	$(MAKE) -C test $@
	$(MAKE) -C tutorial NO_PGXS=1 $@
	$(MAKE) -C test/isolation $@
	$(MAKE) -C test/thread $@
	rm -f Makefile.port Makefile.global

coverage:
	$(MAKE) -C timezone $@
	$(MAKE) -C gtm $@
	$(MAKE) -C backend $@
	$(MAKE) -C backend/utils/mb/conversion_procs $@
	$(MAKE) -C backend/snowball $@
	$(MAKE) -C interfaces $@
	$(MAKE) -C backend/replication/libpqwalreceiver $@
	$(MAKE) -C bin $@
	$(MAKE) -C pl $@


.PHONY: install-local installdirs-local uninstall-local

=== contrib/auto_explain/Makefile ===
# contrib/auto_explain/Makefile

MODULE_big = auto_explain
OBJS = auto_explain.o

ifdef USE_PGXS
PG_CONFIG = pg_config
PGXS := $(shell $(PG_CONFIG) --pgxs)
include $(PGXS)
else
subdir = contrib/auto_explain
top_builddir = ../..
include $(top_builddir)/src/Makefile.global
include $(top_srcdir)/contrib/contrib-global.mk
endif

=== contrib/dblink/Makefile ===
# contrib/dblink/Makefile

MODULE_big = dblink
OBJS	= dblink.o
PG_CPPFLAGS = -I$(libpq_srcdir)
SHLIB_LINK = $(libpq)
SHLIB_PREREQS = submake-libpq

EXTENSION = dblink
DATA = dblink--1.0.sql dblink--unpackaged--1.0.sql

REGRESS = dblink

# the db name is hard-coded in the tests
override USE_MODULE_DB =

ifdef USE_PGXS
PG_CONFIG = pg_config
PGXS := $(shell $(PG_CONFIG) --pgxs)
include $(PGXS)
else
subdir = contrib/dblink
top_builddir = ../..
include $(top_builddir)/src/Makefile.global
include $(top_srcdir)/contrib/contrib-global.mk
endif

=== contrib/pgxc_clean/Makefile ===
#-------------------------------------------------------------------------
#
# Makefile for contrib/pgxc_clean
#
# Portions Copyright (c) 2011-2012 Postgres-XC Development Group
#
# $PostgreSQL$
#
#-------------------------------------------------------------------------

PGFILEDESC = "pgxc_clean - Abort prepared transaction for a Postgres-XC Coordinator"
PGAPPICON = win32

PROGRAM= pgxc_clean
OBJS= pgxc_clean.o txninfo.o

#Include GTM objects
gtm_builddir = $(top_builddir)/src/gtm
EX_OBJS = $(gtm_builddir)/common/assert.o \
	  $(gtm_builddir)/client/libgtmclient.a

PG_CPPFLAGS  = -DFRONTEND -DDLSUFFIX=\"$(DLSUFFIX)\" -I$(srcdir) -I$(libpq_srcdir)
PG_LIBS = $(libpq_pgport) $(PTHREAD_LIBS)

ifdef USE_PGXS
PG_CONFIG = pg_config
PGXS := $(shell $(PG_CONFIG) --pgxs)
include $(PGXS)
else
subdir = contrib/pgxc_clean
top_builddir = ../..
include $(top_builddir)/src/Makefile.global
include $(top_srcdir)/contrib/contrib-global.mk
endif

=== contrib/pgxc_ctl/Makefile ===
#-------------------------------------------------------------------------
#
# Makefile for contrib/pgxc_ctl
#
# Portions Copyright (c) 2013 Postgres-XC Development Group
#
# $PostgreSQL$
#
#-------------------------------------------------------------------------

PGFILEDESC = "pgxc_ctl - Provide XC configuration and opeation"
PGAPPICON = win32

PROGRAM= pgxc_ctl
OBJS= bash_handler.o config.o pgxc_ctl.o pgxc_ctl_bash.o variables.o pgxc_ctl_log.o do_command.o \
	 utils.o do_shell.o gtm_cmd.o coord_cmd.o datanode_cmd.o gtm_util.o mcxt.o monitor.o


#Include GTM objects
gtm_builddir = $(top_builddir)/src/gtm
EX_OBJS = $(gtm_builddir)/common/assert.o \
	  $(gtm_builddir)/client/libgtmclient.a \
	  $(gtm_builddir)/common/gtm_serialize.o

PG_CPPFLAGS  = -DFRONTEND -DDLSUFFIX=\"$(DLSUFFIX)\" -I$(srcdir) -I$(libpq_srcdir)
PG_LIBS = $(libpq_pgport) $(PTHREAD_LIBS) $(EX_OBJS)

ifdef USE_PGXS
PG_CONFIG = pg_config
PGXS := $(shell $(PG_CONFIG) --pgxs)
include $(PGXS)
else
subdir = contrib/pgxc_clean
top_builddir = ../..
include $(top_builddir)/src/Makefile.global
include $(top_srcdir)/contrib/contrib-global.mk
endif

pgxc_ctl_bash.c: pgxc_ctl_conf_part pgxc_ctl_bash_2
	./make_signature
	touch pgxc_ctl_bash.c
	touch pgxc_ctl_bash_conf_part

clean_script:
	rm -f pgxc_ctl_bash.c

=== contrib/pgxc_monitor/Makefile ===
#-------------------------------------------------------------------------
#
# Makefile for contrib/pgxc_clean
#
# Portions Copyright (c) 2011-2012 Postgres-XC Development Group
#
# $PostgreSQL$
#
#-------------------------------------------------------------------------

PGFILEDESC = "pgxc_clean - Abort prepared transaction for a Postgres-XC Coordinator"
PGAPPICON = win32

PROGRAM= pgxc_monitor
OBJS= pgxc_monitor.o mcxt.o

#Include GTM objects
gtm_builddir = $(top_builddir)/src/gtm
EX_OBJS = $(gtm_builddir)/common/assert.o \
	  $(gtm_builddir)/client/libgtmclient.a \
	  $(gtm_builddir)/common/gtm_serialize.o

PG_CPPFLAGS  = -DFRONTEND -DDLSUFFIX=\"$(DLSUFFIX)\" -I$(srcdir) -I$(libpq_srcdir)
PG_LIBS = $(libpq_pgport) $(PTHREAD_LIBS) $(EX_OBJS)

ifdef USE_PGXS
PG_CONFIG = pg_config
PGXS := $(shell $(PG_CONFIG) --pgxs)
include $(PGXS)
else
subdir = contrib/pgxc_monitor
top_builddir = ../..
include $(top_builddir)/src/Makefile.global
include $(top_srcdir)/contrib/contrib-global.mk
endif

=== doc-xc/src/Makefile ===
# doc/src/Makefile

subdir = doc-xc/src
top_builddir = ../..
include $(top_builddir)/src/Makefile.global

all distprep html man install installdirs uninstall clean distclean maintainer-clean maintainer-check:
	$(MAKE) -C sgml $@

=== src/backend/Makefile ===
#-------------------------------------------------------------------------
#
# Makefile for the postgres backend
#
# Portions Copyright (c) 1996-2012, PostgreSQL Global Development Group
# Portions Copyright (c) 1994, Regents of the University of California
#
# src/backend/Makefile
#
#-------------------------------------------------------------------------

PGFILEDESC = "PostgreSQL Server"
# This is a daemon process, which is why it is not labeled as an executable
#PGAPPICON=win32

subdir = src/backend
top_builddir = ../..
include $(top_builddir)/src/Makefile.global

ifneq ($(PORTNAME), win32)
override CFLAGS += $(PTHREAD_CFLAGS)
endif

SUBDIRS = access bootstrap catalog parser commands executor foreign lib libpq \
	pgxc main nodes optimizer port postmaster regex replication rewrite \
	storage tcop tsearch utils $(top_builddir)/src/timezone $(top_builddir)/src/interfaces/libpq

include $(srcdir)/common.mk

# As of 1/2010:
# The probes.o file is necessary for dtrace support on Solaris, and on recent
# versions of systemtap.  (Older systemtap releases just produce an empty
# file, but that's okay.)  However, OS X's dtrace doesn't use it and doesn't
# even recognize the -G option.  So, build probes.o except on Darwin.
# This might need adjustment as other platforms add dtrace support.
ifneq ($(PORTNAME), darwin)
ifeq ($(enable_dtrace), yes)
LOCALOBJS += utils/probes.o
endif
endif

OBJS = $(SUBDIROBJS) $(LOCALOBJS) \
	$(top_builddir)/src/interfaces/libpq/fe-connect.o \
	$(top_builddir)/src/interfaces/libpq/fe-secure.o \
	$(top_builddir)/src/interfaces/libpq/fe-misc.o \
	$(top_builddir)/src/interfaces/libpq/fe-protocol3.o \
	$(top_builddir)/src/interfaces/libpq/fe-protocol2.o \
	$(top_builddir)/src/interfaces/libpq/fe-exec.o \
	$(top_builddir)/src/interfaces/libpq/fe-auth.o \
	$(top_builddir)/src/interfaces/libpq/pqexpbuffer.o \
	$(top_builddir)/src/port/libpgport_srv.a \
	$(top_builddir)/src/gtm/client/libgtmclient.a \
	$(top_builddir)/src/gtm/common/libgtmcommon.a \
	$(top_builddir)/src/interfaces/libpq/libpq.a

# We put libpgport into OBJS, so remove it from LIBS; also add libldap
LIBS := $(filter-out -lpgport, $(LIBS)) $(LDAP_LIBS_BE)

# The backend doesn't need everything that's in LIBS, however
LIBS := $(filter-out -lz -lreadline -ledit -ltermcap -lncurses -lcurses, $(LIBS))

# LIBS := $(LIBS) -lpqcomm
# LDFLAGS += -L$(top_builddir)/src/gtm/libpg
##########################################################################

all: submake-libpgport submake-schemapg postgres $(POSTGRES_IMP)

ifneq ($(PORTNAME), cygwin)
ifneq ($(PORTNAME), win32)
ifneq ($(PORTNAME), aix)

postgres: $(OBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) $(LDFLAGS_EX) -L$(top_builddir)/src/gtm/libpg $(export_dynamic) $(call expand_subsys,$^) $(LIBS) -o $@

endif
endif
endif

ifeq ($(PORTNAME), cygwin)

postgres: $(OBJS) postgres.def libpostgres.a
	$(DLLTOOL) --dllname $@$(X) --output-exp $@.exp --def postgres.def
	$(CC) $(CFLAGS) $(LDFLAGS) $(LDFLAGS_EX) -o $@$(X) -Wl,--base-file,$@.base $@.exp $(call expand_subsys,$(OBJS)) $(LIBS)
	$(DLLTOOL) --dllname $@$(X) --base-file $@.base --output-exp $@.exp --def postgres.def
	$(CC) $(CFLAGS) $(LDFLAGS) $(LDFLAGS_EX) -Wl,--stack,$(WIN32_STACK_RLIMIT) -o $@$(X) $@.exp $(call expand_subsys,$(OBJS)) $(LIBS)
	rm -f $@.exp $@.base

postgres.def: $(OBJS)
	$(DLLTOOL) --export-all --output-def $@ $(call expand_subsys,$^)

libpostgres.a: postgres.def
	$(DLLTOOL) --dllname postgres.exe --def postgres.def --output-lib $@

endif # cygwin

ifeq ($(PORTNAME), win32)
LIBS += -lsecur32

postgres: $(OBJS) postgres.def libpostgres.a $(WIN32RES)
	$(DLLTOOL) --dllname $@$(X) --output-exp $@.exp --def postgres.def
	$(CC) $(CFLAGS) $(LDFLAGS) $(LDFLAGS_EX) -o $@$(X) -Wl,--base-file,$@.base $@.exp $(call expand_subsys,$(OBJS)) $(WIN32RES) $(LIBS)
	$(DLLTOOL) --dllname $@$(X) --base-file $@.base --output-exp $@.exp --def postgres.def
	$(CC) $(CFLAGS) $(LDFLAGS) $(LDFLAGS_EX) -Wl,--stack=$(WIN32_STACK_RLIMIT) -o $@$(X) $@.exp $(call expand_subsys,$(OBJS)) $(WIN32RES) $(LIBS)
	rm -f $@.exp $@.base

postgres.def: $(OBJS)
	$(DLLTOOL) --export-all --output-def $@ $(call expand_subsys,$^)

libpostgres.a: postgres.def
	$(DLLTOOL) --dllname postgres.exe --def postgres.def --output-lib $@

endif # win32

ifeq ($(PORTNAME), aix)

postgres: $(POSTGRES_IMP)
	$(CC) $(CFLAGS) $(LDFLAGS) $(LDFLAGS_EX) $(call expand_subsys,$(OBJS)) -Wl,-bE:$(top_builddir)/src/backend/$(POSTGRES_IMP) $(LIBS) -o $@

$(POSTGRES_IMP): $(OBJS)
	$(LD) $(LDREL) $(LDOUT) SUBSYS.o $(call expand_subsys,$^)
ifeq ($(host_os), aix3.2.5)
	$(MKLDEXPORT) SUBSYS.o $(bindir)/postgres > $@
else
ifneq (,$(findstring aix4.1, $(host_os)))
	$(MKLDEXPORT) SUBSYS.o $(bindir)/postgres > $@
else
	$(MKLDEXPORT) SUBSYS.o . > $@
endif
endif
	@rm -f SUBSYS.o

endif # aix

# Update the commonly used headers before building the subdirectories
$(SUBDIRS:%=%-recursive): $(top_builddir)/src/include/parser/gram.h $(top_builddir)/src/include/catalog/schemapg.h $(top_builddir)/src/include/utils/fmgroids.h $(top_builddir)/src/include/utils/errcodes.h $(top_builddir)/src/include/utils/probes.h

# run this unconditionally to avoid needing to know its dependencies here:
submake-schemapg:
	$(MAKE) -C catalog schemapg.h

# src/port needs a convenient way to force errcodes.h to get built
submake-errcodes: $(top_builddir)/src/include/utils/errcodes.h

.PHONY: submake-schemapg submake-errcodes

catalog/schemapg.h: | submake-schemapg

$(top_builddir)/src/port/libpgport_srv.a: | submake-libpgport

# Those are rules to create dependent GTM libraries automatically
$(top_builddir)/src/interfaces/libpq/libpq.a:
	$(MAKE) -C $(top_builddir)/src/interfaces/libpq libpq.a

$(top_builddir)/src/gtm/common/libgtmcommon.a:
	$(MAKE) -C $(top_builddir)/src/gtm/common libgtmcommon.a

$(top_builddir)/src/gtm/client/libgtmclient.a:
	$(MAKE) -C $(top_builddir)/src/gtm/client libgtmclient.a

# The postgres.o target is needed by the rule in Makefile.global that
# creates the exports file when MAKE_EXPORTS = true.
postgres.o: $(OBJS)
	$(CC) $(LDREL) $(LDFLAGS) $(LDFLAGS_EX) $(call expand_subsys,$^) $(LIBS) -o $@


# The following targets are specified in make commands that appear in
# the make files in our subdirectories. Note that it's important we
# match the dependencies shown in the subdirectory makefiles!

parser/gram.h: parser/gram.y
	$(MAKE) -C parser gram.h

utils/fmgroids.h: utils/Gen_fmgrtab.pl catalog/Catalog.pm $(top_srcdir)/src/include/catalog/pg_proc.h
	$(MAKE) -C utils fmgroids.h

utils/errcodes.h: utils/generate-errcodes.pl utils/errcodes.txt
	$(MAKE) -C utils errcodes.h

utils/probes.h: utils/probes.d
	$(MAKE) -C utils probes.h

# Make symlinks for these headers in the include directory. That way
# we can cut down on the -I options. Also, a symlink is automatically
# up to date when we update the base file.
#
# The point of the prereqdir incantation in some of the rules below is to
# force the symlink to use an absolute path rather than a relative path.
# For headers which are generated by make distprep, the actual header within
# src/backend will be in the source tree, while the symlink in src/include
# will be in the build tree, so a simple ../.. reference won't work.
# For headers generated during regular builds, we prefer a relative symlink.

$(top_builddir)/src/include/parser/gram.h: parser/gram.h
	prereqdir=`cd '$(dir $<)' >/dev/null && pwd` && \
	  cd '$(dir $@)' && rm -f $(notdir $@) && \
	  $(LN_S) "$$prereqdir/$(notdir $<)" .

$(top_builddir)/src/include/catalog/schemapg.h: catalog/schemapg.h
	prereqdir=`cd '$(dir $<)' >/dev/null && pwd` && \
	  cd '$(dir $@)' && rm -f $(notdir $@) && \
	  $(LN_S) "$$prereqdir/$(notdir $<)" .

$(top_builddir)/src/include/utils/errcodes.h: utils/errcodes.h
	prereqdir=`cd '$(dir $<)' >/dev/null && pwd` && \
	  cd '$(dir $@)' && rm -f $(notdir $@) && \
	  $(LN_S) "$$prereqdir/$(notdir $<)" .

$(top_builddir)/src/include/utils/fmgroids.h: utils/fmgroids.h
	prereqdir=`cd '$(dir $<)' >/dev/null && pwd` && \
	  cd '$(dir $@)' && rm -f $(notdir $@) && \
	  $(LN_S) "$$prereqdir/$(notdir $<)" .

$(top_builddir)/src/include/utils/probes.h: utils/probes.h
	cd '$(dir $@)' && rm -f $(notdir $@) && \
	    $(LN_S) "../../../$(subdir)/utils/probes.h" .


utils/probes.o: utils/probes.d $(SUBDIROBJS)
	$(DTRACE) $(DTRACEFLAGS) -C -G -s $(call expand_subsys,$^) -o $@


##########################################################################

# Be sure that these files get removed by the maintainer-clean target
distprep:
	$(MAKE) -C parser	gram.c gram.h scan.c
	$(MAKE) -C bootstrap	bootparse.c bootscanner.c
	$(MAKE) -C catalog	schemapg.h postgres.bki postgres.description postgres.shdescription
	$(MAKE) -C replication	repl_gram.c repl_scanner.c
	$(MAKE) -C utils	fmgrtab.c fmgroids.h errcodes.h
	$(MAKE) -C utils/misc	guc-file.c
	$(MAKE) -C utils/sort	qsort_tuple.c


##########################################################################

install: all installdirs install-bin
ifeq ($(PORTNAME), cygwin)
ifeq ($(MAKE_DLL), true)
	$(INSTALL_DATA) libpostgres.a '$(DESTDIR)$(libdir)/libpostgres.a'
endif
endif
ifeq ($(PORTNAME), win32)
ifeq ($(MAKE_DLL), true)
	$(INSTALL_DATA) libpostgres.a '$(DESTDIR)$(libdir)/libpostgres.a'
endif
endif
	$(MAKE) -C catalog install-data
	$(MAKE) -C tsearch install-data
	$(INSTALL_DATA) $(srcdir)/libpq/pg_hba.conf.sample '$(DESTDIR)$(datadir)/pg_hba.conf.sample'
	$(INSTALL_DATA) $(srcdir)/libpq/pg_ident.conf.sample '$(DESTDIR)$(datadir)/pg_ident.conf.sample'
	$(INSTALL_DATA) $(srcdir)/utils/misc/postgresql.conf.sample '$(DESTDIR)$(datadir)/postgresql.conf.sample'
	$(INSTALL_DATA) $(srcdir)/access/transam/recovery.conf.sample '$(DESTDIR)$(datadir)/recovery.conf.sample'

install-bin: postgres $(POSTGRES_IMP) installdirs
	$(INSTALL_PROGRAM) postgres$(X) '$(DESTDIR)$(bindir)/postgres$(X)'
ifneq ($(PORTNAME), win32)
	@rm -f '$(DESTDIR)$(bindir)/postmaster$(X)'
	ln -s postgres$(X) '$(DESTDIR)$(bindir)/postmaster$(X)'
else
	$(INSTALL_PROGRAM) postgres$(X) '$(DESTDIR)$(bindir)/postmaster$(X)'
endif
ifeq ($(MAKE_EXPORTS), true)
	$(INSTALL_DATA) $(POSTGRES_IMP) '$(DESTDIR)$(pkglibdir)/$(POSTGRES_IMP)'
	$(INSTALL_PROGRAM) $(MKLDEXPORT) '$(DESTDIR)$(pgxsdir)/$(MKLDEXPORT_DIR)/mkldexport.sh'
endif

.PHONY: install-bin

installdirs:
	$(MKDIR_P) '$(DESTDIR)$(bindir)' '$(DESTDIR)$(datadir)'
ifeq ($(PORTNAME), cygwin)
ifeq ($(MAKE_DLL), true)
	$(MKDIR_P) '$(DESTDIR)$(libdir)'
endif
endif
ifeq ($(PORTNAME), win32)
ifeq ($(MAKE_DLL), true)
	$(MKDIR_P) '$(DESTDIR)$(libdir)'
endif
endif
ifeq ($(MAKE_EXPORTS), true)
	$(MKDIR_P) '$(DESTDIR)$(pkglibdir)'
	$(MKDIR_P) '$(DESTDIR)$(pgxsdir)/$(MKLDEXPORT_DIR)'
endif


##########################################################################

uninstall:
	rm -f '$(DESTDIR)$(bindir)/postgres$(X)' '$(DESTDIR)$(bindir)/postmaster'
ifeq ($(MAKE_EXPORTS), true)
	rm -f '$(DESTDIR)$(pkglibdir)/$(POSTGRES_IMP)'
	rm -f '$(DESTDIR)$(pgxsdir)/$(MKLDEXPORT_DIR)/mkldexport.sh'
endif
ifeq ($(PORTNAME), cygwin)
ifeq ($(MAKE_DLL), true)
	rm -f '$(DESTDIR)$(libdir)/libpostgres.a'
endif
endif
ifeq ($(PORTNAME), win32)
ifeq ($(MAKE_DLL), true)
	rm -f '$(DESTDIR)$(libdir)/libpostgres.a'
endif
endif
	$(MAKE) -C catalog uninstall-data
	$(MAKE) -C tsearch uninstall-data
	rm -f '$(DESTDIR)$(datadir)/pg_hba.conf.sample' \
	      '$(DESTDIR)$(datadir)/pg_ident.conf.sample' \
	      '$(DESTDIR)$(datadir)/postgresql.conf.sample' \
	      '$(DESTDIR)$(datadir)/recovery.conf.sample'


##########################################################################

clean:
	rm -f $(LOCALOBJS) postgres$(X) $(POSTGRES_IMP) \
		$(top_builddir)/src/include/parser/gram.h \
		$(top_builddir)/src/include/catalog/schemapg.h \
		$(top_builddir)/src/include/utils/fmgroids.h \
		$(top_builddir)/src/include/utils/probes.h
ifeq ($(PORTNAME), cygwin)
	rm -f postgres.dll postgres.def libpostgres.a
endif
ifeq ($(PORTNAME), win32)
	rm -f postgres.dll postgres.def libpostgres.a $(WIN32RES)
endif

distclean: clean

=== src/bin/Makefile ===
#-------------------------------------------------------------------------
#
# Makefile for src/bin (client programs)
#
# Portions Copyright (c) 1996-2012, PostgreSQL Global Development Group
# Portions Copyright (c) 1994, Regents of the University of California
#
# src/bin/Makefile
#
#-------------------------------------------------------------------------

subdir = src/bin
top_builddir = ../..
include $(top_builddir)/src/Makefile.global

SUBDIRS = gtm_ctl initdb initgtm pg_ctl pg_dump \
	psql scripts pg_config pg_controldata pg_resetxlog pg_basebackup

ifeq ($(PORTNAME), win32)
SUBDIRS += pgevent
else
ALWAYS_SUBDIRS += pgevent
endif

$(recurse)
$(recurse_always)

=== debian/changelog ===
postgres-xc (1.1-2ubuntu2) trusty; urgency=low

  * Backport upstream patch to resolve FTBFS with new bison.

 -- Daniel T Chen <crimsun@ubuntu.com>  Mon, 07 Apr 2014 13:39:08 -0400

postgres-xc (1.1-2ubuntu1) trusty; urgency=medium

  * Use autotools-dev to update config.{sub,guess} for new arches.

 -- Logan Rosen <logan@ubuntu.com>  Sun, 22 Dec 2013 03:35:27 -0500

postgres-xc (1.1-2) unstable; urgency=low

  * Patch build system to work on s390x (Closes: #725636)

 -- Michael Meskes <meskes@debian.org>  Fri, 22 Nov 2013 16:19:11 +0100

postgres-xc (1.1-1) unstable; urgency=low

  * Imported Upstream version 1.1 (Closes: #721777)
  * List team as maintainer.
  * Adjusted patches for new upstream version.

 -- Michael Meskes <meskes@debian.org>  Tue, 10 Sep 2013 14:15:21 +0200

=== debian/control ===
Source: postgres-xc
Section: database
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian PostgreSQL Maintainers <pkg-postgresql-public@lists.alioth.debian.org>
Uploaders: Michael Meskes <meskes@debian.org>
Build-Depends: debhelper (>= 8.0.0),
 dpkg-dev (>= 1.16.1~) | hardening-wrapper,
 perl (>= 5.8),
 libperl-dev,
 libpq-dev,
 tcl8.5-dev,
 libedit-dev,
 libssl-dev, 
 zlib1g-dev | libz-dev,
 libpam0g-dev | libpam-dev,
 libxml2-dev, libkrb5-dev,
 libldap2-dev,
 libxslt1-dev,
 libossp-uuid-dev,
 python-dev,
 bison,
 flex,
 openjade,
 docbook-dsssl,
 docbook-xsl,
 opensp,
 xsltproc,
 gettext,
 autotools-dev
Standards-Version: 3.9.4
Homepage: http://postgres-xc.sourceforge.net/
Vcs-Git: git://anonscm.debian.org/pkg-postgresql/postgres-xc.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-postgresql/postgres-xc.git

Package: postgres-xc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, postgres-xc-client,
 adduser, ssl-cert (>= 1.0.11), logrotate
Conflicts: postgresql-common
Description: write-scalable, synchronous multi-master, transparent PostgreSQL cluster
 Write-scalable means Postgres-XC can be configured with as many
 database servers as you want and handle many more writes (updating SQL
 statements) compared to what a single database server can not do.
 .
 Multi-master means you can have more than one database server that
 clients connect to which provide a single, consistent cluster-wide view
 of the database.
 .
 Synchronous means any database update from any database server is
 immediately visible to any other transactions running on different
 masters.
 .
 Transparent means you (and your applications) do not have to worry
 about how your data is stored in more than one database servers
 internally.
 .
 You can configure Postgres-XC to run on multiple servers. Your data is
 stored in a distributed way, that is, partitioned or replicated, as
 chosen by you for each table. When you issue queries, Postgres-XC
 determines where the target data is stored and issues corresponding
 queries to servers containing the target data.

Package: postgres-xc-dbg
Section: debug
Priority: extra
Architecture: any
Depends: ${misc:Depends}, postgres-xc (= ${binary:Version})
Description: debug symbols for postgres-xc
 Write-scalable means Postgres-XC can be configured with as many
 database servers as you want and handle many more writes (updating SQL
 statements) compared to what a single database server can not do.
 .
 Multi-master means you can have more than one database server that
 clients connect to which provide a single, consistent cluster-wide view
 of the database.
 .
 Synchronous means any database update from any database server is
 immediately visible to any other transactions running on different
 masters.
 .
 Transparent means you (and your applications) do not have to worry
 about how your data is stored in more than one database servers
 internally.
 .
 You can configure Postgres-XC to run on multiple servers. Your data is
 stored in a distributed way, that is, partitioned or replicated, as
 chosen by you for each table. When you issue queries, Postgres-XC
 determines where the target data is stored and issues corresponding
 queries to servers containing the target data.
 .
 This package provides detached debugging symbols for Postgres-XC.

Package: postgres-xc-doc
Section: doc
Priority: extra
Architecture: all
Depends: ${misc:Depends}
Description: documentation for the Postgres-XC cluster
 This package contains all README files, user manual, and examples for
 Postgres-XC. The manual is in HTML format.
 .
 Postgres-XC is a write-scalable, synchronous multi-master, transparent
 PostgreSQL cluster.

Package: postgres-xc-client
Architecture: any
Depends: ${misc:Depends},
 ${shlibs:Depends}
Suggests: postgres-xc, postgresql-xc-doc
Conflicts: postgresql-client-common
Description: front-end programs for Postgres-XC
 This package contains client and administrative programs for
 Postgres-XC: these are the interactive terminal client psql and
 programs for creating and removing users and databases.
 .
 This is the client package for Postgres-XC. If you install
 Postgres-XC on a standalone machine, you need the server package
 postgres-xc, too. On a network, you can install this package on
 many client machines, while the server package may be installed on
 only one machine.
 .  
 Postgres-XC is a write-scalable, synchronous multi-master, transparent
 PostgreSQL cluster.

Package: postgres-xc-server-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
 ${shlibs:Depends},
 libpq-dev (>= 9.2~)
Conflicts: postgresql-common
Description: development files for Postgres-XC server-side programming
 Header files for compiling SSI code to link into Postgres-XC's backend; for
 example, for C functions to be called from SQL.
 .
 This package also contains the Makefiles necessary for building add-on 
 modules of Postgres-XC, which would otherwise have to be built in the
 Postgres-XC source-code tree.
 .
 Postgres-XC is a write-scalable, synchronous multi-master, transparent
 PostgreSQL cluster.

Package: postgres-xc-plperl
Architecture: any
Depends: ${misc:Depends}, 
 ${shlibs:Depends},
 postgres-xc (= ${binary:Version}),
 perl
Description: PL/Perl procedural language for Postgres-XC
 PL/Perl enables an SQL developer to write procedural language functions
 for Postgres-XC in Perl.  You need this package if you have any
 Postgres-XC functions that use the languages plperl or plperlu.
 .
 Postgres-XC is a write-scalable, synchronous multi-master, transparent
 PostgreSQL cluster.

Package: postgres-xc-plpython
Architecture: any
Depends: ${misc:Depends},
 ${shlibs:Depends},
 postgres-xc (= ${binary:Version})
Description: PL/Python procedural language for Postgres-XC
 PL/Python enables an SQL developer to write procedural language functions
 for Postgres-XC in Python.  You need this package if you have any
 Postgres-XC functions that use the languages plpython or plpythonu.
 .
 Postgres-XC is a write-scalable, synchronous multi-master, transparent
 PostgreSQL cluster.

Package: postgres-xc-pltcl
Architecture: any
Depends: ${misc:Depends},
 ${shlibs:Depends},
 postgres-xc (= ${binary:Version})
Description: PL/Tcl procedural language for Postgres-XC
 PL/Tcl enables an SQL developer to write procedural language functions
 for Postgres-XC in Tcl.  You need this package if you have any
 Postgres-XC functions that use the languages pltcl or pltclu.
 .
 Postgres-XC is a write-scalable, synchronous multi-master, transparent
 PostgreSQL cluster.

Package: postgres-xc-contrib
Architecture: any
Depends: postgres-xc (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Suggests: libdbd-pg-perl
Conflicts: postgresql-client-common
Description: additional facilities for Postgres-XC
 The Postgres-XC contrib package provides several additional features
 for the Postgres-XC database.  contrib often serves as a testbed for
 features before they are adopted into PostgreSQL proper:
 .
  adminpack      - File and log manipulation routines, used by pgAdmin
  btree_gist     - B-Tree indexing using GiST (Generalised Search Tree)
  chkpass        - An auto-encrypted password datatype
  cube           - Multidimensional-cube datatype (GiST indexing example)
  dblink         - Functions to return results from a remote database
  earthdistance  - Operator for computing the distance (in miles) between
                   two points on the earth's surface
  fuzzystrmatch  - Levenshtein, metaphone, and soundex fuzzy string matching
  hstore         - Store (key, value) pairs
  intagg         - Integer aggregator/enumerator
  _int           - Index support for arrays of int4, using GiST (benchmark
                   needs the libdbd-pg-perl package)
  isn            - type extensions for ISBN, ISSN, ISMN, EAN13 product numbers
  lo             - Large Object maintenance
  ltree          - Tree-like data structures
  oid2name       - Maps OIDs to table names
  pageinspect    - Inspection of database pages
  passwordcheck  - Simple password strength checker
  pg_buffercache - Real time queries on the shared buffer cache
  pg_freespacemap- Displays the contents of the free space map (FSM)
  pg_trgm        - Determine the similarity of text based on trigram matching
  pg_standby     - Create a warm stand-by server
  pgbench        - TPC-B like benchmark
  pgcrypto       - Cryptographic functions
  pgrowlocks     - A function to return row locking information
  pgstattuple    - Returns the percentage of dead tuples in a table; this
                   indicates whether a vacuum is required.
  seg            - Confidence-interval datatype (GiST indexing example)
  spi            - PostgreSQL Server Programming Interface; 4 examples of
                   its use:
                   autoinc    - A function for implementing AUTOINCREMENT/
                                IDENTITY
                   insert_username - function for inserting user names
                   moddatetime - Update modification timestamps
                   refint     - Functions for implementing referential
                                integrity (foreign keys).  Note that this is
                                now superseded by built-in referential
                                integrity.
                   timetravel - Re-implements in user code the time travel
                                feature that was removed in 6.3.
  tablefunc      - examples of functions returning tables
  uuid-ossp      - UUID generation functions
  vacuumlo       - Remove orphaned large objects
 .
 Postgres-XC is a write-scalable, synchronous multi-master, transparent
 PostgreSQL cluster.

Package: ecpg-xc
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
 ${shlibs:Depends},
 libpq-dev,
 libecpg-dev (>= 9.2~),
 libecpg6 (>= 9.2~),
 libecpg-compat3 (>= 9.2~),
 libpgtypes3 (>= 9.2~)
Description: Postgres-XC version of ECPG (Embedded PostgreSQL for C)
 This package contains the precompiler ECPG (Embedded
 PostgreSQL for C) for parsing Postgres-XC syntax. 
 .
 Postgres-XC is a write-scalable, synchronous multi-master, transparent
 PostgreSQL cluster.
 . 
 Install this package if you want to write C programs with SQL statements
 embedded in them (rather than run by an external process).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

TCL_VER := 8.5

# support both hardening-wrapper (for backports) and dpkg-buildflags
export DEB_BUILD_HARDENING = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie
DPKG_EXPORT_BUILDFLAGS = 1
-include /usr/share/dpkg/buildflags.mk
LDFLAGS+= -Wl,--as-needed -Wl,-z,now
CFLAGS+= -fPIC -pie

# When protecting the postmaster with oom_adj=-17, allow the OOM killer to slay
# the backends (http://archives.postgresql.org/pgsql-hackers/2010-01/msg00170.php)
ifeq ($(shell uname -s),Linux)
CFLAGS+= -DLINUX_OOM_ADJ=0
endif

ifneq ($(findstring $(DEB_BUILD_ARCH), sparc alpha),)
# sparc and alpha's gcc currently miscompiles; see
# http://lists.debian.org/debian-alpha/2007/11/msg00025.html
    CFLAGS+=-O1
endif

export DPKG_GENSYMBOLS_CHECK_LEVEL=4

# build should fail on test suite failures on all arches
TESTSUITE_FAIL_CMD=exit 1

override_dh_auto_clean:
	[ ! -f GNUmakefile ] || make distclean
	-rm -fr build
	-find doc-xc/src/sgml -name "*.sgml" -exec rm -f {} \;
	(cd src/test/regress/sql; \
	  rm -f misc.sql \
	  rm -f create_function_1.sql \
	  rm -f create_function_2.sql \
	  rm -f largeobject.sql \
	  rm -f copy.sql \
	  rm -f constraints.sql \
	  rm -f security_label.sql \
	  rm -f tablespace.sql \
	  rm -f xc_copy.sql)

override_dh_auto_configure:
	mkdir -p build
	cd build && ../configure --prefix=/usr \
		--libdir=/usr/lib/postgres-xc \
		--docdir=/usr/share/doc/postgres-xc-doc \
		--datarootdir=/usr/share \
		--datadir=/usr/share/postgres-xc \
		--includedir=/usr/include/postgres-xc \
		--sysconfdir=/etc \
		--localstatedir=/var \
		--enable-nls \
		--enable-integer-datetimes \
		--enable-thread-safety \
		--enable-debug \
		--disable-maintainer-mode \
		--disable-dependency-tracking \
		--disable-rpath \
		--with-ossp-uuid \
		--with-gnu-ld \
		--with-pgport=5432 \
		--with-system-tzdata=/usr/share/zoneinfo \
		--with-tcl \
		--with-perl \
		--with-python \
		--with-pam \
		--with-krb5 \
		--with-gssapi \
		--with-openssl \
		--with-libxml \
		--with-libxslt \
		--with-ldap \
		--with-tclconfig=/usr/lib/tcl$(TCL_VER) \
		--with-tkconfig=/usr/lib/tk$(TCL_VER) \
		--with-includes=/usr/include/tcl$(TCL_VER) 

override_dh_auto_build:
	cd build && $(MAKE)

override_dh_auto_install:
	make -C build install-world DESTDIR=$(CURDIR)/debian/tmp

override_dh_install:
	dh_install

	# these get installed into the individual -/l* packages; -f because it
	# does not exist for an -A build
	rm -f debian/postgres-xc-contrib/usr/share/postgres-xc/extension/pl*

override_dh_strip:
	dh_strip --dbg-package=postgres-xc-dbg

override_dh_auto_test:
ifeq (, $(findstring nocheck, $(DEB_BUILD_OPTIONS)))
	# patch away the "don't execute as root" check for the test
	# suite; doing it here will ensure that the actual debs have
	# the check.
	set -e; \
	patch --no-backup-if-mismatch -p1 < debian/disable-root-check.patch; \
	patch --no-backup-if-mismatch -p1 < debian/pg_regress-in-tmp.patch; \
	#make -C build/src/test/regress bigcheck || fail=1; \
	patch --no-backup-if-mismatch -Rp1 < debian/pg_regress-in-tmp.patch; \
	patch --no-backup-if-mismatch -Rp1 < debian/disable-root-check.patch; \
	if [ -n "$$fail" ]; then \
	    for l in regression.diffs log/initdb.log log/postmaster.log; do \
	    	if [ -e build/src/test/regress/$$l ]; then \
		    echo "********* $$l *******"; \
		    cat build/src/test/regress/$$l; \
		fi; \
	    done; \
	    $(TESTSUITE_FAIL_CMD); \
	fi
endif

%:
	dh $@ --with autotools_dev

=== debian/watch ===
version=3
opts=uversionmangle=s/\.(beta\d*)$/~$1/ \
http://qa.debian.org/watch/sf.php/postgres-xc/ \
	(?:|.*/)pgxc[_\-]v?(\d\S*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)
# Bart Martens <bartm@debian.org>
